import React, { Component } from "react";
import ContentWrapper from "@/components/Layout/ContentWrapper";
import Link from "next/link";
import { Row, Col, Button } from "reactstrap";
import { getPelaporan } from "@/actions/pelaporan";
import CaseProgress from "@/components/Main/CaseProgress";
import TableLaporan from "@/components/Main/TableLaporan";
import { connect } from "react-redux";

class Pelaporan extends Component {
	constructor(props) {
		super(props);
		this.state = {
			user: {
				pelaporan: {},
			},
		};
	}

	componentDidMount = async () => {
		const { organisasi, peran } = this.props.user.peran[0];
		const query = { role: peran.id === 2021 ? "lldikti" : "dikti" };
		if (peran.id === 2021) query.orgId = organisasi.id;
		const pelaporan = await getPelaporan(query);
		this.setState({ pelaporan });
	};

	render() {
		const { pelaporan } = this.state;
		return (
			<ContentWrapper>
				<div className="content-heading">Pelaporan</div>
				<Row>
					<Col lg="4">
						<CaseProgress />
					</Col>
					<Col lg="8">
						<div className="mb-3 d-flex">
							<div>
								<Link href="/app/pelaporan/search">
									<Button color="primary">Laporan Baru</Button>
								</Link>
							</div>
						</div>
						<TableLaporan listData={pelaporan?.data} to="/app/pelaporan/detail" linkName="Detail" />
					</Col>
				</Row>
			</ContentWrapper>
		);
	}
}

const mapStateToProps = (state) => ({ user: state.user });
export default connect(mapStateToProps)(Pelaporan);
